## otpclient 4.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(OTPClient VERSION "4.0.1" LANGUAGES "C")
include(GNUInstallDirs)

configure_file("src/common/version.h.in" "version.h")

set (GETTEXT_PACKAGE ${CMAKE_PROJECT_NAME})

include_directories(${PROJECT_BINARY_DIR})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(IS_FLATPAK "Use flatpak app's config folder to store the database" OFF)
option(BUILD_GUI "Build the GTK UI" ON)
option(BUILD_CLI "Build the CLI" ON)

set(CMAKE_C_STANDARD 11)
set(COMMON_C_FLAGS
        "-Wall -Wextra -O3 -Wformat=2 -Wmissing-format-attribute -fstack-protector-strong"
        "-Wundef -Wmissing-format-attribute -fdiagnostics-color=always"
        "-Wstrict-prototypes -Wunreachable-code -Wchar-subscripts"
        "-Wwrite-strings -Wpointer-arith -Wbad-function-cast -Wcast-align"
        "-Werror=format-security -Werror=implicit-function-declaration -Wno-sign-compare"
        "-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3"
)

if(CMAKE_COMPILER_IS_GNUCC)
    list(APPEND COMMON_C_FLAGS "-pie -fPIE")
endif()

if(IS_FLATPAK)
    list(APPEND COMMON_C_FLAGS "-DIS_FLATPAK")
endif()

string(REPLACE ";" " " COMMON_C_FLAGS "${COMMON_C_FLAGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMMON_C_FLAGS}")

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(COMMON_LINKER_FLAGS
            "-Wl,--no-add-needed -Wl,--as-needed -Wl,--no-undefined"
            "-Wl,-z,relro,-z,now"
    )

    string(REPLACE ";" " " COMMON_LINKER_FLAGS "${COMMON_LINKER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${COMMON_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${COMMON_LINKER_FLAGS}")
endif()

add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")


if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed -Wl,--no-undefined")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,-z,now")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro,-z,now")
endif()

find_package(PkgConfig REQUIRED)
find_package(Protobuf 3.6.0 REQUIRED)
find_package(Gcrypt 1.10.1 REQUIRED)
pkg_check_modules(COTP REQUIRED cotp>=3.0.0)
pkg_check_modules(PNG REQUIRED libpng>=1.6.30)
pkg_check_modules(JANSSON REQUIRED jansson>=2.12)
pkg_check_modules(ZBAR REQUIRED zbar>=0.20)
pkg_check_modules(GTK3 REQUIRED gtk+-3.0>=3.24.0)
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.68.0)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.68.0)
pkg_check_modules(UUID REQUIRED uuid>=2.34.0)
pkg_check_modules(PROTOC REQUIRED libprotobuf-c>=1.3.0)
pkg_check_modules(LIBSECRET REQUIRED libsecret-1>=0.20.0)
pkg_check_modules(LIBQRENCODE REQUIRED libqrencode>=4.0.2)

set(COMMON_INCDIRS
        ${GCRYPT_INCLUDE_DIRS}
        ${COTP_INCLUDE_DIRS}
        ${JANSSON_INCLUDE_DIRS}
        ${UUID_INCLUDE_DIRS}
        ${PROTOC_INCLUDE_DIRS}
        ${LIBSECRET_INCLUDE_DIRS}
        ${LIBQRENCODE_INCLUDE_DIRS}
)

set(COMMON_LIBS
        ${GCRYPT_LIBRARIES}
        ${COTP_LIBRARIES}
        ${JANSSON_LIBRARIES}
        ${UUID_LIBRARIES}
        ${PROTOC_LIBRARIES}
        ${LIBSECRET_LIBRARIES}
        ${LIBQRENCODE_LIBRARIES}
)

if(BUILD_GUI)
    add_subdirectory(src/gui)
    target_link_libraries(${PROJECT_NAME}
            ${GTK3_LIBRARIES}
            ${PNG_LIBRARIES}
            ${ZBAR_LIBRARIES}
            ${COMMON_LIBS}
    )
    set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "otpclient")

    install(TARGETS ${PROJECT_NAME} DESTINATION bin)
    install(FILES data/com.github.paolostivanin.OTPClient.desktop DESTINATION share/applications)
    install(FILES man/otpclient.1 DESTINATION share/man/man1)

    set(GUI_UI_FILES
            src/gui/ui/otpclient.ui
            src/gui/ui/add_popover.ui
            src/gui/ui/settings_popover.ui
            src/gui/ui/security_settings.ui
            src/gui/ui/shortcuts.ui
    )
    install(FILES ${GUI_UI_FILES} DESTINATION share/otpclient)

    set(GUI_ICON_FILES
            data/icons/com.github.paolostivanin.OTPClient.svg
            data/icons/com.github.paolostivanin.OTPClient-symbolic.svg
    )
    install(FILES ${GUI_ICON_FILES} DESTINATION share/icons/hicolor/scalable/apps)
endif ()

if(BUILD_CLI)
    add_subdirectory(src/cli)
    target_link_libraries(${PROJECT_NAME}-cli
            ${COMMON_LIBS}
    )
    set_target_properties(${PROJECT_NAME}-cli PROPERTIES OUTPUT_NAME "otpclient-cli")

    install(TARGETS ${PROJECT_NAME}-cli DESTINATION bin)
    install(FILES man/otpclient-cli.1 DESTINATION share/man/man1)
endif()

install(FILES data/com.github.paolostivanin.OTPClient.appdata.xml DESTINATION share/metainfo)

=== debian/changelog ===
otpclient (4.0.1-1) unstable; urgency=medium

  * New upstream version 4.0.1.
  * Update debian/otpclient.install to add the missing ui file.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Fri, 02 Aug 2024 11:34:43 +0000

otpclient (4.0.0-1) unstable; urgency=medium

  * New upstream version 4.0.0.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 30 Jul 2024 15:53:34 +0000

otpclient (3.7.0-1) unstable; urgency=medium

  * New upstream version 3.7.0.
  * Drop debian/manpage/.
  * Drop debian/not-installed.
  * Drop debian/otpclient-cli.1.
  * Drop debian/otpclient.1.
  * debian/otpclient-cli.manpages file pointing to upstream.
  * debian/otpclient.manpages file pointing to upstream.
  * Drop debian/patches/002-fix-freeotp-export.patch.
  * Update debian/otpclient-cli.install.
  * Update debian/otpclient.install.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Wed, 24 Jul 2024 15:59:30 +0000

=== debian/control ===
Source: otpclient
Section: utils
Priority: optional
Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libcotp-dev,
               libgcrypt20-dev,
               libgtk-3-dev,
               libjansson-dev,
               libpng-dev,
               libprotobuf-c-dev,
               libprotobuf-dev,
               libqrencode-dev,
               libsecret-1-dev,
               libzbar-dev,
               libzip-dev,
               pkgconf
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/paolostivanin/OTPClient
Vcs-Browser: https://salsa.debian.org/debian/otpclient
Vcs-Git: https://salsa.debian.org/debian/otpclient.git

Package: otpclient
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: otpclient-cli (= ${binary:Version})
Description: Simple GTK+ software to generate OTPs (TOTP and HOTP)
 OTPClient is GTK+ software for two-factor authentication
 that supports both Time-based One-time Passwords (TOTP)
 and HMAC-Based One-Time Passwords (HOTP).
 .
 Features:
  - Support both TOTP and HOTP.
  - Support setting custom digits (between 4 and 10 inclusive).
  - Support setting a custom period (between 10 and 120 seconds inclusive).
  - Support SHA1, SHA256 and SHA512 algorithms.
  - Support for Steam codes.
  - Import encrypted Authenticator Plus backup.
  - Import and export encrypted and/or plain andOTP backup.
  - Import and export plain FreeOTPPlus backup (key URI format only).
  - Import and export plain Aegis backup (plain json only).
  - Local database is encrypted using AES256-GCM.
     * Key is derived using PBKDF2 with SHA512 and 100k iterations.
     * Decrypted file is never saved (and hopefully never swapped) to disk.
       While the app is running, the decrypted content resides
       in a "secure memory" buffer allocated by Gcrypt.

Package: otpclient-cli
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: otpclient (= ${binary:Version})
Description: command-line for OTPClient
 OTPClient-CLI is simplified version of OTPClient.
 Only two operations are supported:
  - list: this will print all pairs of account and issuer
    that are in the database.
  - show: this will show the OTP for a given account/issuer.

## otpclient 4.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.16)
-project(OTPClient VERSION "4.0.1" LANGUAGES "C")
+project(OTPClient VERSION "4.0.2" LANGUAGES "C")
 include(GNUInstallDirs)
 
 configure_file("src/common/version.h.in" "version.h")

=== debian/changelog ===
otpclient (4.0.2-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Use libcotp-dev version 3.0.0.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Fri, 30 Aug 2024 11:53:58 +0000

otpclient (4.0.2-1) unstable; urgency=medium

  * New upstream version 4.0.2.
  * Bump Standards-Version to 4.7.0.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Fri, 16 Aug 2024 23:09:33 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libcotp-dev,
+               libcotp-dev (>= 3.0.0),
                libgcrypt20-dev,
                libgtk-3-dev,
                libjansson-dev,
@@ -16,7 +16,7 @@
                libzbar-dev,
                libzip-dev,
                pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/paolostivanin/OTPClient
 Vcs-Browser: https://salsa.debian.org/debian/otpclient

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/v$1\/v$1\.tar\.gz\.asc/ \
https://github.com/paolostivanin/OTPClient/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## otpclient 4.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.16)
-project(OTPClient VERSION "4.0.2" LANGUAGES "C")
+project(OTPClient VERSION "4.1.1" LANGUAGES "C")
 include(GNUInstallDirs)
 
 configure_file("src/common/version.h.in" "version.h")
@@ -13,6 +13,7 @@
 option(IS_FLATPAK "Use flatpak app's config folder to store the database" OFF)
 option(BUILD_GUI "Build the GTK UI" ON)
 option(BUILD_CLI "Build the CLI" ON)
+option(ENABLE_MINIMIZE_TO_TRAY "Enable minimize to tray feature" OFF)
 
 set(CMAKE_C_STANDARD 11)
 set(COMMON_C_FLAGS
@@ -46,8 +47,13 @@
     set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${COMMON_LINKER_FLAGS}")
 endif()
 
-add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")
-
+add_definitions(
+    -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\"
+    -DDESTINATION="${CMAKE_INSTALL_PREFIX}"
+)
+if (ENABLE_MINIMIZE_TO_TRAY)
+  add_definitions(-DENABLE_MINIMIZE_TO_TRAY=1)
+endif()
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed -Wl,--no-undefined")
@@ -70,6 +76,9 @@
 pkg_check_modules(PROTOC REQUIRED libprotobuf-c>=1.3.0)
 pkg_check_modules(LIBSECRET REQUIRED libsecret-1>=0.20.0)
 pkg_check_modules(LIBQRENCODE REQUIRED libqrencode>=4.0.2)
+if (ENABLE_MINIMIZE_TO_TRAY)
+  pkg_check_modules(APPINDICATOR REQUIRED ayatana-appindicator3-0.1)
+endif()
 
 set(COMMON_INCDIRS
         ${GCRYPT_INCLUDE_DIRS}
@@ -93,12 +102,18 @@
 
 if(BUILD_GUI)
     add_subdirectory(src/gui)
+    if(ENABLE_MINIMIZE_TO_TRAY)
+        target_include_directories(${PROJECT_NAME} PRIVATE ${APPINDICATOR_INCLUDE_DIRS})
+    endif()
     target_link_libraries(${PROJECT_NAME}
             ${GTK3_LIBRARIES}
             ${PNG_LIBRARIES}
             ${ZBAR_LIBRARIES}
             ${COMMON_LIBS}
     )
+    if(ENABLE_MINIMIZE_TO_TRAY)
+        target_link_libraries(${PROJECT_NAME} ${APPINDICATOR_LIBRARIES})
+    endif()
     set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "otpclient")
 
     install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== src/cli/CMakeLists.txt ===
file(GLOB CLI_HEADER_FILES
        *.h
        ../common/*.h
)

file(GLOB CLI_SOURCE_FILES
        *.c
        ../common/*.c
)

include_directories(
        ${COMMON_INCDIRS}
)

add_executable(${PROJECT_NAME}-cli ${CLI_SOURCE_FILES} ${CLI_HEADER_FILES})

=== src/gui/CMakeLists.txt ===
file(GLOB GUI_HEADER_FILES
        *.h
        ../common/*.h
)

file(GLOB GUI_SOURCE_FILES
        *.c
        ../common/*.c
)

include_directories(
        ${GTK3_INCLUDE_DIRS}
        ${PNG_INCLUDE_DIRS}
        ${ZBAR_INCLUDE_DIRS}
        ${COMMON_INCDIRS}
)

add_executable(${PROJECT_NAME} ${GUI_SOURCE_FILES} ${GUI_HEADER_FILES})

=== debian/changelog ===
otpclient (4.1.1-1) unstable; urgency=medium

  * New upstream version 4.1.1. (Closes: #1098822)
  * Bump Standards-Version to 4.7.2.
  * Remove "Rules-Requires-Root: no" (default since dpkg 1.22.13).
  * Update upstream and packaging copyright years.
  * Refresh patch.
  * Update debian/watch from the old "version=4" syntax
    to the new "Version: 5" RFC-822 style format.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 30 Sep 2025 15:26:00 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libcotp-dev (>= 3.0.0),
+               libcotp-dev,
                libgcrypt20-dev,
                libgtk-3-dev,
                libjansson-dev,
@@ -16,8 +16,7 @@
                libzbar-dev,
                libzip-dev,
                pkgconf
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://github.com/paolostivanin/OTPClient
 Vcs-Browser: https://salsa.debian.org/debian/otpclient
 Vcs-Git: https://salsa.debian.org/debian/otpclient.git

=== debian/watch ===
Version: 5
Template: Github
Owner: paolostivanin
Project: @PACKAGE@
Download-Url-Mangle: s%api.github.com/repos/([^/]+)/([^/]+)/git/refs/tags/(@ANY_VERSION@)%github.com/$1/$2/archive/refs/tags/$3/$3.tar.gz%g
Pgp-Sig-Url-Mangle: s%(https://github\.com/[^/]+/[^/]+)/archive/refs/tags/(.+)%$1/releases/download/$2.asc%g
